# MPI_Scatter

Sends data from one task to all other tasks in a group

## Synopsis

    #include "mpi.h"
    int MPI_Scatter (
            void *sendbuf,
            int sendcnt,
            MPI_Datatype sendtype,
            void *recvbuf,
            int recvcnt,
            MPI_Datatype recvtype,
            int root,
            MPI_Comm comm )

## Input Parameters

| sendbuf | address of send buffer (choice, significant only at `root`)
| sendcount | number of elements sent to each process (integer, significant only at `root`)
| sendtype | data type of send buffer elements (significant only at `root`) (handle)
| recvcount | number of elements in receive buffer (integer)
| recvtype | data type of receive buffer elements (handle)
| root | rank of sending process (integer)
| comm | communicator (handle)

## Output Parameter

recvbuf
  address of receive buffer (choice)

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Errhandler_set`; the predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_COMM
  Invalid communicator. A common error is to use a null communicator in a call (not even allowed in `MPI_Comm_rank`).

MPI_ERR_COUNT
  Invalid count argument. Count arguments must be non-negative; a count of zero is often valid.

MPI_ERR_TYPE
  Invalid datatype argument. May be an uncommitted MPI_Datatype (see `MPI_Type_commit`).

MPI_ERR_BUFFER
  Invalid buffer pointer. Usually a null buffer where one is not valid.

Location:scatter.c